
# ---------------------------------------------------- 
# @Function: abi.sys.comp(seqno=0,bufcomp=1)
# @+	     complementaire	
# @Purpose:  donne le complementaire de la sequence	
# @+	      place dans le buffer seqno		
# @+	      et la place dans le buffer bufcomp
# @Note:     < LC > add 16 Mar 00			
# ----------------------------------------------------

revComp  <- function(seqno=0,force=FALSE)
 {
   ## If revComp does not exists: create !
   size <- .seqSize()
   if(size$sequences[seqno+1] != size$complementaire[seqno+1])
     return(.C("buf_complementaire",as.integer(seqno),PACKAGE="GeneR") [[1]])

   ## If it exists... computation only if force = TRUE
   if(force)
     return(.C("buf_complementaire",as.integer(seqno),PACKAGE="GeneR") [[1]])

   return(seqno)
 }




# --------------------
# @Function: abi.str.comp (s)
# @Type: C
# @Purpose: retourne le complementaire d'une sequence et l'inverse
# --------------------

strComp <- function (s)
{
  if(is.null(s))
    return(NULL)
  if(nchar(s) == 0)
    return(NULL)
  
  .C("str_complementaire",.abi.str.reverse(s),
     PACKAGE="GeneR") [[1]]
	
}	




# --------------------
# @Function: abi.str.reverse (s)
# @Type: C
# @Purpose: reverse string
# @+        returns the created string
# --------------------

.abi.str.reverse <- function(s)
{
   .C("reverse_string", s,PACKAGE="GeneR")[[1]]
}

