

# ---------------------------------------------------- 
# @Function: abi.sys.dna_rna(seqno, limites)
# @+	     dna_rna			
# @Purpose:  transforme les T en U dans la squence 	
# @+	      contenue dans le seqno seqno
# Note:	     [LC] created 05 sep 00		
# ---------------------------------------------------- 

dnaToRna  <- function (seqno=0,from = 1, to = 0)
{	
  limites <- list(from, to)
	
  liste <- .transf.limites(seqno, limites)

  if(liste[[1]] == -1)
    {
      warning("error in the transformation of the limits")
      return (NULL)
    }
		
  from <- liste[[2]]
  to <- liste[[3]]
  
  comp <- getStrand()	# lire le brin dans les variables globales
	
  if (comp == 1)
    {
      if (revComp(seqno) == -1)
        return (NULL)
    }
  
  .C("dna_rna", as.integer(seqno),as.integer(from),
            as.integer(to), as.integer(comp),
            length(from),PACKAGE="GeneR")[[1]]
 		 
}

# ---------------------------------------------------- 
# @Function: abi.sys.rna_dna(seqno, limites)
# @+	     rna_dna			
# @Purpose:  transforme les U en T dans la squence 	
# @+	      contenue dans le seqno seqno
# Note:	     [LC] created 05 sep 00		
# ---------------------------------------------------- 

rnaToDna  <- function (seqno=0, from = 1, to = 0)
{
  limites <- list(from,to)
  
  liste <- .transf.limites(seqno, limites)
	
  if(liste[[1]] == -1)
    {
      warning("error in the transformation of the limits")
      return (NULL)
    }
		
  from <- liste[[2]]
  to <- liste[[3]]

  comp <- getStrand()

  if (comp == 1)
    {
      if (revComp(seqno) == -1)
        return (NULL)
    }

  .C("rna_dna", as.integer(seqno),as.integer(from),
            as.integer(to), as.integer(comp),
            length(from),PACKAGE="GeneR")[[1]]
  
}


