as.globalSeg <- function (segments)
  {

    class(segments) <- NULL
    if(is.data.frame(segments) || is.matrix(segments))
     {
        ## We suppose it a matrix or data.frame
        ## Make a list
       if(ncol(segments) != 2)
         {
           warning("as.globalSeg error")
           return(NA)
         }
       segments <- as.list(as.data.frame(t(segments)))
       segments <- lapply(segments,function(u){matrix(as.matrix(u),ncol=2)})

       class(segments) <- "globalSeg"
       names(segments) <- NULL
       return(segments)       
     }
    else
      {
        segments <- lapply(segments,function(u){if(!is.null(u)){matrix(as.matrix(u),ncol=2)}})
        class(segments) <- "globalSeg"
        return(segments)
      }


  }

.nrow <- function(u)
  {
    if(!is.null(u))
      nrow(u)
    else
      0
  }

as.matrix.globalSeg <- function(x,...)
  {
    res <- NULL
    lapply(x,function(u){if(!is.null(u)){names(u) <- NULL; res <<- rbind(res,u) }; 1  })
    res <- as.matrix(res)
    res

  }

##
## at,tick,xlabels: labels on X axis
## 
plot.globalSeg <- function(x,xlim=range(x,global=TRUE),border="darkblue",col="darkblue",density=NULL,at= NULL,tick=TRUE,xlabels=TRUE,...)
  {
    if(is.null(x))
      {
        plot.new()
        return()
      }
    n <- length(x)
    plot.new()
    ylim <- c(0.5,n)
    plot.window(xlim,ylim)
    usr <- par()$usr
    usr[1] <- xlim[1]
    usr[2] <- xlim[2]
    par(usr=usr)
    axis(1,tick=tick,at=at,labels=xlabels)
    mat <- as.matrix(x)
    indices <- NULL
    maxi <- 1
    if(length(col) == length(x))
      {
        ##col <- col[!sapply(x,is.null)]
        col <- rep(col,sapply(x,.nrow))
        if(length(border) != length(x))
          border <- col
      }
    else
      if(length(border) == length(x))
        {
          ##border <- border[!sapply(x,is.null)]        
          border <- rep(border,sapply(x,.nrow))        
        }
    lapply(x,function(u){if(!is.null(u)){indices <<- c(indices,rep(maxi,nrow(u)))};maxi <<- maxi+1})
    rect(xleft=mat[,1],ybottom=maxi-indices-0.5,xright=mat[,2],ytop=maxi-indices,border=border,col=col,density=density)
    title(...)

  }


or <- or.default <- function(a, b=NULL, ...)
  {
    if (is.null(attr(a, "class")))
       {a|b}
    else {UseMethod("or")}
  }

"|.globalSeg" <- function(...) or.globalSeg(...)
or.globalSeg <- function(a,b=NULL, byrows=FALSE,...)
{

  if(!is.null(b))
    {
      a <- as.globalSeg(a)
      b <- as.globalSeg(b)
      if (byrows) 
        { 
           if (length(a)== length(b)) 
              {
                 i<- 1    
                 res <- NULL
                 lapply(a,function(u){ 
                   res[[i]] <<- unionSeg(rbind(u,b[[i]]))
                   i<<- i+1
                   return(0)
                 })
                 return ( as.globalSeg(res))
              }
          else {print("Different length of lists") ; return (NULL)}  
        } else a <- c(a,b)
    }
  a <- as.globalSeg(a)
  envel <- unionSeg(as.matrix(range(a)))
  a <- unionSeg(as.matrix(a))
  return(relistage(a,envel=envel))

}



## XOR : exclusive union
Xor <- Xor.default <- function(a,b=NULL)
  {
     if (is.null(attr(a, "class")))
       {xor(a,b)}
    else { UseMethod("Xor")}
  }


Xor.globalSeg <- function(a,b=NULL,...)
  {
    if(!is.null(b))
      {
        a <- as.globalSeg(a)
        b <- as.globalSeg(b)
        a <- or(a)
        b <- or(b)
        envel <- unionSeg(as.matrix(range(or(a,b))))
        c <-a&b
        d <- a|b
        if(is.null(c))
          return(d)
        res <- xorRecouvr(as.matrix(c),envel = as.matrix(d))
         if (is.null(res)){
           return(NULL)
         } else {
        return(relistage(res,envel=envel))
      }
      }
    envel <- unionSeg(as.matrix(range(a)))
    a <- as.globalSeg(a)
    C <- as.globalSeg(a[[1]]) & a[-1]
    D <- or(a)
    anew <- a[2:length(a)]
    i<-2
    lapply(anew,function(u){
      ## In C: union of all intersections
      C <<- or(C,a[-i] & as.globalSeg(u));
      i<<- i+1
      return(0);
    })
    res <- xorRecouvr(as.matrix(C),envel = as.matrix(D))
    res <- relistage(res,envel=envel)
    return(as.globalSeg(res))
  }

## range

range.globalSeg <- function (globalSeg, na.rm = FALSE,global=FALSE,...)
  {
    if(global)
        return(range(unclass(globalSeg), na.rm = na.rm))
    else     
      as.globalSeg(t(sapply(globalSeg,function(u){range(u,na.rm = na.rm)})))
  }

## AND : intersection

and <- and.default <-function(a,b=NULL, ...)
  { 
    if (is.null(attr(a, "class")))
      {a&b}
    else
      UseMethod("and")
  }

"&.globalSeg" <- function(...) and.globalSeg(...)
and.globalSeg <- function(a,b=NULL,global=FALSE, byrows=FALSE,relist=TRUE, ...)
{
  if(!is.null(b))
    {
      global <- TRUE

      if (byrows) 
        { if (length(a)== length(b)) 
            {
               i <- 0
               res <- NULL
               lapply(a,function(u){
                  i <<- i + 1
                  res [[i]] <<- and(as.globalSeg(u),as.globalSeg(b[[i]]))[[1]]
                  return (0)
               })
               length(res) = i
               class(res) <- "globalSeg"
               return(res)
              }
          else {print("Different length of lists") ; return (NULL)}
        } 
      else
        { a <- or(as.globalSeg(a))
          b <- or(as.globalSeg(b))
          envela =  as.matrix(range(a,global=FALSE))
          envelb =  as.matrix(range(b,global=FALSE))
          maxseq =  unionSeg(rbind(envela,envelb))
          a <- as.matrix(a)
          b <- as.matrix(b)
          a <- list(a,b)
        }
    }
  a <- as.globalSeg(a)
  ## (1) on s'occupe de la sequence minimale de l puis de son contraire

  ## envel: enveloppe of our globalSeg
  envel <- as.matrix(range(a,global=FALSE))
  envel <-  envel[order(envel[,1]),]
  envel <- matrix(envel,ncol=2)

  minseq <- .minimalSeg(envel)
  minseq <- minseq[order(minseq[,1]),]
  minseq <- matrix(minseq,ncol=2)
  mini <- min(envel) - 1
  maxi <- max(envel) + 1


  if(global)
    {
      if(max(envel[,1]) < min(envel[,2]))
        minseq <- matrix(c(max(envel[,1]) , min(envel[,2])),ncol=2)
      else
        minseq <- NULL
    }
  
  if(!is.null(minseq))
    {
      n = nrow(minseq)
      
      mini <- min(envel) - 1
      maxi <- max(envel) + 1

      ## complementary of minseq
      contr1 = matrix(c(mini,minseq[1:n,2],minseq[1:n],maxi),ncol=2)
    }
  else
    contr1 = matrix(c(mini,maxi),ncol=2)


  ## (2) on s'occupe de la sequence maximale de l : enveloppes
  if(!global)
    maxseq = unionSeg(envel)

  ## (3) on calcule l'union des complmentaires de a :
  contr2 <- NULL
  lapply(a,function(u){n <- nrow(u) ; if(n>1) {contr2 <<-rbind(contr2, cbind(u[1:(n-1),2],u[2:n,1]))} ;0 })
  contr2 <- unionSeg( matrix( contr2[contr2[,1]<contr2[,2],],ncol=2 ))
  
  ## (4) on fait l'union du contraire de la squence minimale de a et de l'union des complmentaires de a  :
  contr3 = rbind(contr1,contr2)
  contr4 = contr3[order(contr3[,1]),]
  total = unionSeg(contr4)
  n = nrow(total)
  ## on calcule son contraire :
  if(n>1)
    res = cbind(total[1:n-1,2],total[2:n])
  else
    return(NULL)
  ## on obtient ainsi un vecteur de l'intersection de a

  ## (5) on fait le relistage entre les enveloppes et les intersections trouves :
  if (!relist)
    {
      return (as.globalSeg(res))
    }
  else
    {
      return (relistage(res,envel=maxseq))
    }

}

## NOT


not <- not.default <- function(a,b)
  {
    UseMethod("not")
  }
"-.globalSeg" <- not.globalSeg <- function(a,b=NULL)
{ 
  a <- as.globalSeg(a)
  ## envel: enveloppe of our globalSeg
  envel <- as.matrix(range(a,global=FALSE))
  envel <-  envel[order(envel[,1]),]
  envel <- matrix(envel,ncol=2)
  maxseq = unionSeg(envel)
 if(!is.null(b))
    { 
      a <- or(a)
      b <- or(as.globalSeg(b))
      c =  Xor.globalSeg(a,b)
      if (is.null(c)) {return(NULL)}
      else
        {
          res = and(a=a,b=c)
          if(is.null(res))
            return (res)          
          res = as.matrix(res)
        }
    }
  else res =  xorRecouvr(as.matrix(a),envel)
  
  if(is.null(res))
    return(NULL)
  
  ## on fait le relistage entre les enveloppes et les intersections trouves :
  return (result = relistage(res,envel=maxseq))
}


## Size of all models

size <- size.default <- function(a)
  UseMethod("size")
  
size.globalSeg <- function(a)
{ 
  a <- as.globalSeg(a)

  ## envel: enveloppe of our globalSeg
  envel <- as.matrix(range(a,global=FALSE))
  envel <- matrix(envel,ncol=2)
  v = envel[,2]-envel[,1] +1
  return (v)
}


## Minimum  of all models
Min <- Min.default <- Min.globalSeg <- function(a)
{ 
  a <- as.globalSeg(a)
  ## envel: enveloppe of our globalSeg
  envel <- as.matrix(range(a,global=FALSE))
  envel <- matrix(envel,ncol=2)
  return (c(lapply(a,min),recursive = TRUE))  
}


## Minimal size of all models
Max <- Max.default <- Max.globalSeg <- function(a)
{ 
  a <- as.globalSeg(a)
  ## envel: enveloppe of our globalSeg
  envel <- as.matrix(range(a,global=FALSE))
  envel <- matrix(envel,ncol=2)
  return (c(lapply(a,max),recursive = TRUE))
}

## Number of globalSeg in all models
Length <- Length.default <- Length.globalSeg <- function(a, global=TRUE)
{ 
 if(global) return(length(unclass(a)))
    else return(c(lapply(a,nrow),recursive = TRUE))
}


## Un petit exemple
##
## con <- dbConnect("MySQL", host="genome-mysql.cse.ucsc.edu", user="genome", dbname="hg17")

## rs <- dbSendQuery(con, statement = paste(
##                         "SELECT * ",
##                         "FROM knownGene",
##                         "WHERE chrom = 'chr3'",
##                         "AND strand = '+'"
##                         ))
## ucscSQLdata <- fetch(rs, n = -1)

## interv <- apply(ucscSQLdata,1,function(u){ cbind(as.integer(strsplit(as.character(u[9]),",")[[1]]),as.integer(strsplit(as.character(u[10]),",")[[1]])) })
## interv <- as.globalSeg(interv)


