## ----------------------------------------------------
## @File: shuffle.R
## @Synopsis: All to shuffle seq or random sequences
##
## @History: <Gloup> 30 Oct 2005 created by A. LUCAS
## Last modified: Time-stamp: <2005-11-02 09:01:11 lucas>
##

## Create random sequence with frequency of nucleotides / bi-tri nucleotides
## prob can be a result of compoSeq (then letters is ignored).
## (tirage aleatoire avec remise)
randomSeq <- function(prob=c(0.25,0.25,0.25,0.25,0),letters=c("T","C","A","G","N"),n)
{
  if(sum(prob) != 1)
    {
      warning("prob must be with sum = 1")
      return(NULL)
    }  
  if(is.matrix(prob) && (length(letters) != ncol(prob) ))
    {
      letters <- dimnames(prob)[[2]]
      if(is.null(letters))
        return(NULL)
    }
  ##  step <- nchar(letters[1]) 
  ##  repetition <- floor(length / step)

  paste(sample(letters,n,prob=prob,replace=TRUE),collapse="")
}


## Assemble sequence from numbers of nucleotides
## (tirage aleatoire sans remise)
shuffleSeq <- function(count,letters=c("T","C","A","G","N"))
{
  if(sum(count) == 1)
    {
      warning("count must not be frequencies but nucleotides count")
      return(NULL)
    }
  if(is.matrix(count) && (length(letters) != ncol(count) ))
    {
      letters <- dimnames(count)[[2]]
      if(is.null(letters))
        return(NULL)
    }
  i <- 0
  ids <- c(lapply(count,function(u){i <<- i+1; rep(i,u) }),recursive=TRUE)
  paste(letters[sample(ids)],collapse="")
}
