



##
## This function returns all the segments that overlap.
## A FAIRE !!!
## I.e.
## from = c(1, 15,17,100,130,135,142)
## to   = c(40,45,38,120,140,145,160)
## interSeg(data.frame(from,to)) 
##  

##interSeg  <- function(ranges,global = FALSE) {
##  NULL
##}

##
## This function returns the maximal common segment when two segments overlap.
##
## I.e.
## from = c(1, 15,17,100,130,135,142)
## to   = c(40,45,38,120,140,145,160)
## minimalSeg(data.frame(from,to)) 
##  17  38
##  100 120
.minimalSeg <- function(ranges)
  {
    from <- ranges[,1]
    to <-ranges[,2]
    ordr <- order(from)
    from <- from[ordr]
    to <- to[ordr]
    n <-  length(from)
    res <- .C("vec_minimal",
              from=as.double(from),
              to=as.double(to),
              n=as.integer(n),
              dup=FALSE,
              PACKAGE="GeneR")

    n <- res$n +1
    from <- res$from[1:n]
    to <- res$to[1:n]
    indx <- from < to
    return(cbind(from[indx],to[indx]))

  }


## Relist : put all ranges into its specific enveloppe
## Return : un vecteur des indices des enveloppes les contenant strictement (-1 si aucun)
## I.e :

## from = c(1, 15,17,100,130,135,142)
## to   = c(40,45,38,120,140,145,160)
## envelfrom = c(1,100,130,140)
## envelto = c(45,120,139,160)
## ranges = data.frame(from,to)
## envel = data.frame(envelfrom,envelto)
## Note: envel must be disjoint

## Usage:
## relist(ranges,envel)
## 1  1  1  2 -1 -1  4
## Erreur quand ranges n'est pas ordonnee


relist <- function(ranges,envel)
  {
    indices <-  order(ranges[,1])
    if (nrow(ranges)==1)
      {   
        ranges <- matrix(ranges,ncol=2)
      } else {ranges <- ranges[indices,]}
    if (nrow(envel)==1)
      {
        envel <- matrix(envel,ncol=2)
      } else { envel <- envel[order(envel[,1]),]}
    ## Verifier l'integrite des donnees:
    if(sum(ranges[,1]>ranges[,2]) >0 )
      error("Positions of ranges must be ...")
    ## enveloppes disjointes
    ## a faire...

    n = as.integer(nrow(envel))
    m = as.integer(nrow(ranges))
    
    res <- .C("relist",from1=as.integer(envel[,1]),
       to1=as.integer(envel[,2]),
       from2=as.integer(ranges[,1]),
       to2=as.integer(ranges[,2]),
       res=as.integer(rep(-1,m)),
       n,
       m,
       dup=FALSE,
       PACKAGE="GeneR")$res

    return(res[order(indices)])
    
  }

relistage <- function(ranges,envel)
  {
    indices <- relist(ranges= ranges,envel=envel)
    res <- list()
    apply(cbind(ranges,indices),1,function(u) {if(length(res) >= u[3]) {res[[u[3]]] <<- rbind(res[[u[3]]],u[1:2])  }  else { res[[u[3]]] <<- matrix(u[1:2],1) } ; 1 } )

   res <- res[!sapply(res, is.null)]

    as.globalSeg(res)

  }



xorRecouvr <- function (ranges,envel)
  {
    envel <- matrix(envel,ncol=2)
    envel <- envel[order(envel[,1]),]
    envel <- matrix(envel,ncol=2)

    ranges <- unionSeg(ranges)
    ranges <- ranges[order(ranges[,1]),]
    ranges <- matrix(ranges,ncol=2)
    n <- nrow(envel)
    mini <- envel[1,1]-1
    maxi <- envel[n,2]+1
    n2 <- nrow(ranges)
    mini2 <- ranges[1,1]-1
    maxi2 <- ranges[n2,2]+1
    mini <- min(c(mini,mini2))
    maxi <- max(c(maxi,maxi2))
    envelcompfrom <- c(mini,envel[1:n,2])
    envelcompto <- c(envel[1:n,1],maxi)
  
    names(ranges)<- NULL
    all <- rbind(ranges,cbind(envelcompfrom,envelcompto))

    all <- unionSeg(all)
    n = nrow(all)
    if(n == 1)
      return(NULL)

    cbind(all[1:(n-1),2],all[2:n,1])
    
  }

