# ------------------------------------------------------------------------- #
# CompleteStringWithSpace                                                   #
# Ajoute des espaces  la fin d'une chane de caractre juqu' obtenir le   #
# nombre voulu de caractres                                                #
# In :                                                                      #
#    - Str.In :                                                             #
#       Chane de caratres  complter                                     #
#    - nbChar :                                                             #
#       Nombre de caractre que la chane doit avoir                        #
# Out :                                                                     #
# ------------------------------------------------------------------------- #
.completeStringWithSpace <- function (Str.In, nbChar)
  {
    while (nchar (Str.In) < nbChar)
      {
        Str.In <- paste (Str.In, "")
      }
    return (Str.In)
  }
# ------------------------------------------------------------------------- #
# WriteEmblLine                                                             #
# Ecrit dans un fichier une ligne au format Embl                            #
# In :                                                                      #
#    - File    :                                                            #
#       Fichier dans lequel crire la ligne au format Embl                  #
#    - Code :                                                               #
#       Code sur 2 lettres  crire au dbut de la ligne                    #
#    - Chp1 :                                                               #
#       Premire partie de la ligne                                         #
#    - Chp2 :                                                               #
#       Deuxime partie de la ligne                                         #
#    - NextField :                                                          #
#       Boolen indiquant si la ligne crire correspond  la dernire du    #
#       champ en cours d'criture. Si True, on crit une ligne de sparation#
#       aprs la ligne qu'on vient d'crire                                 #
#    - Write :                                                              #
#       Boolen True si on veut effectivement crire dans le fichier.       #
#       Si False, la fonction retourne la chane  crire                   #
# Out :                                                                     #
#    - Le fichier avec une ligne crite au format Embl                      #
# ------------------------------------------------------------------------- #
writeEmblLine <- function (file, code = "", header = "", text = "",
                           nextfield = TRUE,append=TRUE)
  {

    ## Vrification de la validit des arguments
    if (nchar (code) != 2)
      {
        warning (paste ("'Code' must have 2 characters:", code))
        return(NULL)
      }
    if( (nchar (header) > 16) && (text!=""))
      {
        warning (paste ("header field  too long:",header))
        return(NULL)
      }
    header <- gsub("\n","",header)
    text <- gsub("\n","",text)
    header <- gsub("\t"," ",header)
    text <- gsub("\t"," ",text)
    nlines <- 0

    ## Construction et ecriture de la 1ere ligne Embl
    code <- .completeStringWithSpace (code, 5)
    header <- .completeStringWithSpace (header, 16)
    dat <- paste (code, header, sep = "")
    dat0 <- .completeStringWithSpace (code, 21)

    if(nchar(text) == 0)
      write (dat,file,append=append)
    
      
    while(nchar(text)>0)
    {
      nlines <- nlines +1
 
      i<-60
       if(nchar(text) >59)
         {
           while((substr(text,i,i) != ' ') && (i>0))        
             i <- i-1
         }
      tmp <- substr(text,0,i-1)
      if(i==0)
        {
          tmp <- substr(text,0,59)
          i <-59
        }
      if( nlines >1)
        append <- TRUE
      write (paste(dat,tmp,sep=""),file,append=append)
      dat <- dat0
      text <- substring(text,i+1)
    }
          
    ## Ecriture d'un sparateur de champ
    if (nextfield)
      write ("XX",file= file,append= TRUE)

    return(1)
  }


# ------------------------------------------------------------------------- #
# writeEmblComment                                                          #
#
# ------------------------------------------------------------------------- #
writeEmblComment <- function (file, code = "", text = "",
                           nextfield = TRUE, append=TRUE)
{


  text <- gsub("\n","",text)
  text <- gsub("\t"," ",text)
  nlines <- 0
  while(nchar(text)>0)
    {
      nlines <- nlines +1
 
      i<-76
      if(nchar(text) >74)
         {
           while((substr(text,i,i) != ' ') && (i>0))        
             i <- i-1
         }
      tmp <- substr(text,0,i-1)
      if(i==0)
        {
          tmp <- substr(text,0,75)
          i <-75
        }
      if( nlines >1)
        append <- TRUE
      write (paste(code,tmp,sep="   "),file,append=append)

      text <- substring(text,i+1)
    }

   # Ecriture d'un sparateur de champ
  if (nextfield)
    write ("XX",file= file,append= TRUE)
}

# ------------------------------------------------------------------------- #
# writeEmblSeq                                                              #
# Ecrit dans un fichier une squence au format Embl                         #
# In :                                                                      #
#    - file :                                                            #
#       Fichier dans lequel crire la squence                              #
#    - seqno :                                                              #
#       Numro du buffseq contenant la squence                             #
# Out :                                                                     #
#    - Le fichier avec la squence crite au format Embl                    #
# ------------------------------------------------------------------------- #
writeEmblSeq <- function (file, seqno = 0)
  {
    seq <- getSeq (seqno)
    taille <- nchar (seq)
    comp <- compoSeq (seqno = seqno, wsize = 1, p = 0)
    nbA <- comp[1,"A"]
    nbC <- comp[1,"C"]
    nbG <- comp[1,"G"]
    nbT <- comp[1,"T"]
    nbX <- comp[1,"X"]
    # Construction du premier champ de la ligne Embl
    Chp1 <- paste ("Sequence", taille, "BP;", nbA, "A;", nbC, "C;", nbG, "G;", nbT, "T;", nbX, "other;")
    # Ecriture de l'en-tte de la squence
    writeEmblLine (file, code = "SQ", header = Chp1, nextfield = FALSE)
    # Ecriture de la squence
    seq <- tolower (seq)
    i <- 1
    while (i < taille)
      {
        dat <- ""
        seqtmp <- substr (seq, i, i + 59)
        ltmp <- nchar (seqtmp)
        j <- 1
        # ajout d'un espace tous les 10 nt
        while (j <= ltmp)
          {
            dat <- paste (dat, substr (seqtmp, j, j + 9), " ", sep = "")
            j <- j + 10
          }
        dat <- .completeStringWithSpace (dat, 66)
        nbtmp <- as.character (i + ltmp - 1)
        if (nchar (nbtmp) == 2)  nbnt <- paste ("      ", nbtmp)
        if (nchar (nbtmp) == 3)  nbnt <- paste ("     ", nbtmp)
        if (nchar (nbtmp) == 4)  nbnt <- paste ("    ", nbtmp)
        if (nchar (nbtmp) == 5)  nbnt <- paste ("   ", nbtmp)
        if (nchar (nbtmp) == 6)  nbnt <- paste ("  ", nbtmp)
        if (nchar (nbtmp) == 7)  nbnt <- paste (" ", nbtmp)
        if (nchar (nbtmp) == 8)  nbnt <- paste ("", nbtmp)
        if (nchar (nbtmp) == 9)  nbnt <- nbtmp
        dat <- paste (dat, nbnt, sep = "")
        writeEmblLine (file, code = "  ", header = dat, nextfield = FALSE)
        i <- i + ltmp
      }
    write ("//", file, append=TRUE)
  }
