\name{AtoR} 
\alias{AtoR}
\alias{AtoT}
\alias{RtoA}
\alias{RtoT}
\alias{TtoA}
\alias{TtoR}

\title{Conversion of addresses}
\description{
  Converts addresses on a sequence according to the working strand 
  and the address type (A : absolute, T : true, R : relative) .
}
\usage{
AtoR(x, seqno=0)
AtoT(x, seqno=0)
RtoA(x, seqno=0)
RtoT(x, seqno=0)
TtoA(x, seqno=0)
TtoR(x, seqno=0)

}
\arguments{
 \item{x}{Integer/vector. Addresses }
 \item{seqno}{Integer/scalar, Sequence number (buffer number)}
}
\value{
  Integer vector with new addresses
}

\details{
  All details on addresses and global variables are on the page \code{\link{globals}}.
  
}

\note{
  All results depend on the value of Strand. See:
  \code{\link{setStrand}}, \code{\link{getStrand}}.
}

\author{L. Cottret}

\keyword{utilities}

\seealso{\code{\link{AtoT}}, \code{\link{RtoA}}, \code{\link{RtoT}},
  \code{\link{TtoA}},
  \code{\link{TtoR}},\code{\link{setStrand}}, \code{\link{getStrand}} }

\examples{


s<-"cgtagtagctagctagctagctagctagc"
placeString (s, seqno=0)
# s of size 30
address <- c(4,20)

# On reverse strand:
setStrand(1)
AtoR(address)
#[1] 26 10

# On forward strand does nothing:
setStrand(0)
AtoR(address)
#[1]  4 20


}

