\name{appendSeq}
\alias{appendSeq}
\title{Appends two sequences}
\description{appends a sequence at the end of another one}

\usage{
appendSeq(destSeqno=0, seqno=1)
}

\arguments{
  \item{destSeqno}{Sequence number of sequence to be appended}
  \item{seqno}{Sequence number of sequence to add at the end of destSeqno}
}

\note{This function frees the reverse complementary of sequence destSeqno}

\value{
  0: no error; NULL if error and a warning if problem in memory allocation.
}


\examples{
  s <- "CTGCGTTTGAAAA"
  placeString(s,seqno=0)
  placeString(s,seqno=1)
  appendSeq(0,1)
  getSeq(0)

}

\author{Antoine Lucas}

\seealso{\code{\link{getSeq}}, \code{\link{concat}} ,\code{\link{assemble}}}

\keyword{utilities}

