\name{Concat}
\alias{concat}
\title{Concatenation of two sequences}
\description{
  Concatenates a fragment of one sequence with a fragment of another one.
}
\usage{
concat(seqno1=0, seqno2=1, destSeqno=2, from1=1, to1=0, strand1=getStrand(),
from2=1, to2=0, strand2=getStrand())

}
\arguments{
 \item{seqno1}{Integer/scalar, Integer/scalar, First sequence number (buffer number)}
 \item{seqno2}{Integer/scalar, Integer/scalar, Second sequence number (buffer number)}
 \item{destSeqno}{Integer/scalar, Output sequence number (buffer number)}
 \item{strand1}{Integer/scalar, Strand of the first fragment (forward: 0, reverse: 1)}
 \item{from1,to1}{Integer/scalar, Absolute addresses of the beginning and the end of the first fragment,
  (1 means the first nucleotide and 0 conventionally the last one; 
  from must not be larger than to and both vectors must be the same size).
 }
 \item{from2,to2}{Integer/scalar, Absolute addresses of the beginning and the end of the second fragment,
  (1 means the first nucleotide and 0 conventionally the last one; 
  from must not be larger than to and both vectors must be the same size)
 }
 \item{strand2}{Integer/scalar, Strand of the second fragment (forward: 0, reverse: 1)}
}

\value{
destSeq or -1 if error

% to do : NULL if error.
}

\author{L.Cottret }
\keyword{utilities}


\seealso{\code{\link{assemble}}, \code{\link{getSeq}},  \code{\link{appendSeq}}}

\examples{

s1<- "aaacgctagcgcg"
placeString(s1)
s2<-"ttttctatcag"
placeString(s2,1)
concat(seqno1=0,seqno2=1, from1=2,to1=3,from2=8,to2=0, strand1=1)
getSeq(2)
#[1] "TTTCAG"
  
}
