\name{DnaToRna}
\alias{dnaToRna}
\alias{rnaToDna}
\title{DNA <-> RNA sequence rewriting }
\description{
Transformation from T to U in a sequence (dnaToRna), and vice versa (rnaToDna).
}
\usage{
dnaToRna(seqno=0, from=1, to=0)
rnaToDna(seqno=0, from=1, to=0)
}
\arguments{
  \item{seqno}{Integer/scalar, Sequence number (buffer number)}
   \item{from, to}{Integer/scalar, Absolute addresses of the beginning and the end of the fragment,
  (1 means the first nucleotide and 0 conventionally the last one; 
  from must not be larger than to and both vectors must be the same size)
 }
}
\value{
  seqno or -1 if error
  
% to do : NULL if error
}
\author{L.Cottret }

\keyword{utilities}


\examples{

s<-"atuuutututu"  
placeString(s)  
dnaToRna()        
getSeq()         
#[1] "auuuuuuuuuu"      
rnaToDna()  
getSeq()         
#[1] "atttttttttt"        

}
