\name{Buffers}
\alias{freeSeq}
\alias{freeAllSeq}
\alias{nSeq}


%\title{Free one or all sequence}
\title{Low level functions on buffer manipulation}
\description{
  nSeq returns the limit of buffers to use, or set this limit to 
  maxBuffers when specified.
  
  freeSeq free sequence seqno and complementary. Free all sequences for freeAllSeq
}
\usage{
freeSeq(seqno=0)
freeAllSeq()
nSeq(maxBuffers=NULL)

}
\arguments{
  \item{seqno}{Integer, sequence number to free.  (bufseq)}
  \item{maxBuffers}{Integer/Scalar, number of buffers}
}


\examples{

placeString("ATGAGTGATGAGATGATGAG",seqno=0)
placeString("ATGAGTGATGAGATGATGAG",seqno=3)
placeString("ATGAGTGATGAGATGATGAG",seqno=4)
revComp()
revComp(seqno=3)

sizeSeq()
## show size used in all buffers
.seqSize()


## freeSeq(3)
## free buffer 3
.seqSize()


freeAllSeq()
## free all buffers
.seqSize()


## show number of availabel buffers:
nSeq()
# 100

## increase number of available buffers
nSeq(150)

.seqSize()
}

\value{
  seqno; 0 for freeAllSeq. Number of sequences for nSeq
}
\author{A.Viari, L Cotteret, A Lucas}

\keyword{utilities}


