\name{getAccn}
\alias{getAccn}
\alias{getBegSeq}
\alias{getEndSeq}
\alias{getSeqSize}
\alias{getStrand}
\title{Reading of a GeneR global variable}
\description{
  Each of these functions returns GeneR global variable associated to a sequence buffer (see \code{\link{globals}}).
  but the global variable \code{strand} which concerns all the sequence buffers.
}
\usage{
getAccn(seqno=0)
getBegSeq(seqno=0)
getSeqSize(seqno=0)
getStrand()
getEndSeq(seqno=0)
}

\arguments{
  \item{seqno}{Integer/scalar, Sequence number (buffer number)}
}
\value{
  \item{getAccno}{Accession number or name of the sequence}
  \item{getBegSeq,getEndSeq,getSeqSize}{Beginning or ending position or size of the loaded sequence}
  \item{getStrand}{Running working strand (0 -> forward, 1 -> reverse)}
   if error : -1
}

\details{
  All details on addresses and GeneR global variables can be found on page \code{\link{globals}}.
  }

\author{L. Cottret}

\seealso{\code{\link{setAccn}},\code{\link{getParam}},\code{\link{setParam}},
  \code{\link{globals}}}

\keyword{utilities}

