\name{getSeq}
\alias{getSeq}

\title{Sequence fragments extraction}

\description{
  Extracts sequence fragments.
  getSeq further converts the fragments in character strings from the GeneR sequence buffer.
}

\usage{

getSeq(seqno=0, strand = getStrand(), from=1, to=0)
}

\arguments{
  \item{seqno}{Integer/scalar, Sequence number (buffer number)}
  \item{from, to}{Integer/scalar, Absolute addresses of the begin and the end of the fragment,
  (1 means the first nucleotide and 0 conventionally the last one; 
  from must not be larger than to and both vectors must be the same size)}
  \item{strand}{Integer/scalar, Strand (forward: 0, reverse: 1)}
  
}
\value{
  A vector of character strings.
  if error : NULL
}
\author{L.Cottret }

%\seealso{\code{\link{getSeq}}}

\examples{
s<-"cgtagtagctagctagctagctagctag"
placeString (s, seqno=1)
getSeq(1,from=c(1,5,10),to=c(5,10,15))
#[1] "CGTAG"  "GTAGCT" "TAGCTA"


# And on the reverse:
setStrand(1)
getSeq(1,from=c(1,5,10),to=c(5,10,15))

## The reverse complement
getSeq(1,strand=1) 

}

\seealso{\code{\link{assemble}}, \code{\link{concat}},
  \code{\link{appendSeq}}, and for character string manipulation: \code{\link{substr}}

}



\keyword{utilities}
