\name{indexFasta}
\alias{indexFasta}
\alias{indexEmbl}
\alias{indexGbk}
\title{Index file creation for a sequences bank}
\description{These functions create an index file for retrieving quickly a sequence into a fasta, 
genbank or embl sequence bank file.}

\usage{
indexFasta(file)
indexEmbl(file,index="ix")
indexGbk(file)
}

\arguments{
  \item{file}{String/scalar, File path and name of the sequences file}
  \item{index}{String/scalar, Suffix for the index file}
}

\value{
  \item{1}{Indexfile has been created}
  \item{-1}{Error}
}

\note{
  These functions create an index file even if it already exists.
  
  Access number larger than 40 characters are skipped (a warning is
  returned). This can be increasing with variable \code{MAX\_LEN\_ACCNO} in
  file GeneR\_globals.h (and rebuild GeneR library).    
}
  
\author{Antoine Lucas}

\seealso{\code{\link{makeIndex}}}


\keyword{utilities}


