\name{not.globalSeg}
\alias{not.globalSeg}
\alias{-.globalSeg}

\title{Substraction of globals segments}
\description{
  Compute substraction of two objects of class
  globalSeg a and b,  i.e. return segments from a that or not in b.

  When used with only one parameter, not(A) returns the complementary of
  each elements of A.
}
\usage{
not.globalSeg(a, b = NULL)
}

\arguments{
  \item{a,b}{elements of class globalSeg}
    
}

\value{
  An element of class globalSeg
}

\author{Odile Rogier}

\seealso{\link{globalSeg},\link{and.globalSeg},\link{not.segSet}}




\examples{

a = list(
    matrix( c( 1, 15, 17,  5, 45, 38),ncol=2),
    matrix( c( 100 , 120),ncol=2),
    matrix( c( 130, 135, 140, 145),ncol=2),
    matrix( c( 142 , 160),ncol=2))


b = list(
    matrix( c(15, 28, 18, 45),ncol=2),
    matrix( c(1, 15, 25, 10, 20, 40),ncol=2),
    matrix( c(17, 35, 23, 38),ncol=2),
    matrix( c(100, 110, 105, 120),ncol=2))

a = as.globalSeg(a)
b = as.globalSeg(b)

c = not(a,b)
par(mfrow=c(5,1))
plot(a,xlim=c(1,160),main="A")
plot(b,xlim=c(1,160),main="B")
plot(c,xlim=c(1,160),main="A-B")
plot(not(b,a),xlim=c(1,160),main="B-A")
plot(not(b),xlim=c(1,160),main="not(B)")

## Show all
c
not(b,a)
not(b)

}

\keyword{utilities}
