\name{or.globalSeg}
\alias{or.globalSeg}
\alias{|.globalSeg}

\title{Union of global segments}
\description{
  This function compute union of two objects of class
  globalSeg a and b.

  When used with only one parameter, or(A) returns the union of
  A.
}
\usage{
or.globalSeg(a, b = NULL, byrows = FALSE,...)
}

\arguments{
  \item{a,b}{elements of class globalSeg}
  \item{byrows}{if TRUE,  \code{a} and \code{b} must be lists of same
    length, and intersection is computed for each elements from \code{a}
    with its homologue in  \code{b}.    
  }
  \item{...}{Unused}

}

\value{
  An element of class globalSeg
}

\author{Odile Rogier}

\seealso{\link{globalSeg},\link{and.globalSeg},\link{or.segSet}}




\examples{

a = list(
    matrix( c( 1, 15, 17,  5, 45, 38),ncol=2),
    matrix( c( 100 , 120),ncol=2),
    matrix( c( 130, 135, 140, 145),ncol=2),
    matrix( c( 142 , 160),ncol=2))


b = list(
    matrix( c(15, 28, 18, 45),ncol=2),
    matrix( c(1, 15, 25, 10, 20, 40),ncol=2),
    matrix( c(17, 35, 23, 38),ncol=2),
    matrix( c(100, 110, 105, 120),ncol=2))

a = as.globalSeg(a)
b = as.globalSeg(b)

c = or(a,b)
par(mfrow=c(4,1))
plot(a,xlim=c(1,160),main="A")
plot(b,xlim=c(1,160),main="B")
plot(c,xlim=c(1,160),main="or(A,B)")

plot(or(b),xlim=c(1,160),main="or(B)")

## Show all
c
or(b)

}

\keyword{utilities}
