\name{placeString}
\alias{placeString}

\title{Sequence loading in a GeneR sequence buffer.}
\description{
Puts a character string into a GeneR sequence buffer.
}
\usage{
placeString(s, seqno=0, upper=TRUE)

}

\arguments{
 \item{s}{Character string to put into a sequence buffer}
 \item{seqno}{Integer/scalar, Sequence number (buffer number)}
 \item{upper}{upper case conversion (TRUE : conversion of the whole sequence in upper case letters,
    FALSE : sequence is taken as such)
  }

}

\value{
  seqno or -1 if error.
}
\author{L.Cottret}
\seealso{\code{\link{getSeq}}}

\examples{

s<-"cgtagtagctagctagctagctagctag"
placeString (s, seqno=0)

getSeq(seqno=0)

placeString (s, seqno=1, upper=FALSE)

getSeq(seqno=1)

}

\keyword{utilities}
