\name{plot.globalSeg}
\alias{plot.globalSeg}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Plot an object of class globalSeg}
\description{
  Draw rectangles on an axis to represent our segments.
}
\usage{
plot.globalSeg(x, xlim = range(x, global = TRUE),
     border = "darkblue", col = "darkblue", density = NULL, at = NULL,
     tick = TRUE, xlabels = TRUE, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{Object of class GlobalSeg}
  \item{xlim}{(optional) vector of two elements: }
  \item{col}{color(s) to fill or shade the rectangle(s) with. The default
          'NULL', or also 'NA' do not fill, i.e., draw transparent
          rectangles, unless 'density' is specified.}
  \item{border}{color for rectangle border(s). Can also be 'FALSE' to
          suppress the border, or 'TRUE' in which case 'col' is used.}
  \item{density}{the density of shading lines, in lines per inch. The default
          value of 'NULL' means that no shading lines are drawn. A zero
          value of 'density' means no shading lines whereas negative
          values (and 'NA') suppress shading (and so allow color
          filling).}
  \item{at}{the points at which tick-marks are to be drawn.  Non-finite
          (infinite, 'NaN' or 'NA') values are omitted.  By default,
          when 'NULL', tickmark locations are computed.}
  \item{tick}{a logical value specifying whether tickmarks should be
    drawn on x axis}
  \item{xlabels}{this can either be a logical value specifying whether
          (numerical) annotations are to be made at the tickmarks, or a
          vector of character strings to be placed at the tickpoints.}
  \item{\dots}{other graphical parameters can be given as arguments.}
}
\details{
  Interval class is described on page \code{\link{globalSeg}}
  
}


\author{Antoine Lucas}

\seealso{See also: \code{\link{globalSeg}}}
\examples{
a = list(
    matrix( c( 1, 15, 17,  5, 45, 38),ncol=2),
    matrix( c( 100 , 120),ncol=2),
    matrix( c( 130, 135, 140, 145),ncol=2),
    matrix( c( 142 , 160),ncol=2))
a = as.globalSeg(a)
plot(a,at=c(a,recursive=TRUE))

}
\keyword{utilities}% at least one, from doc/KEYWORDS


