\name{readEmblDescript}
\alias{readEmblDescript}

\title{Read features from an Embl bank file}
\description{
  Read features from an Embl bank file
}
\usage{
readEmblDescript(file, name = NA, code = "DE")
}

\arguments{
  \item{file}{String/scalar, File name of the bank (example: "foo.embl")}
  \item{name}{String/scalar, Sequence name (default : first sequence)}
  \item{code}{String/scalar, feature code to look for (i.e. "CC", "DE",
    "CC", etc...)}
}
}
\value{
  A vector of character string.
}

\author{Antoine Lucas}

\examples{

\dontrun{
download.file("http://bioinfo.hku.hk/sars/AY291451.seq",
destfile="AY291451.seq")

readEmblDescript(file = "AY291451.seq",name ="AY291451",code ="DE")

##returns: "SARS coronavirus TW1, complete genome."


readEmblDescript(file = "AY291451.seq",name ="AY291451",code ="OC")

##returns: "Viruses; ssRNA positive-strand viruses, no DNA stage; Nidovirales; Coronaviridae; Coronavirus; SARS coronavirus."

readEmblDescript(file = "AY291451.seq",name ="AY291451",code ="RA")
##[1] "Yeh S.-H., Kao C.-L., Tsai C.-Y., Liu C.-J., Chen D.-S., Chen P.-J.;"
##[2] "Yeh S.-H., Kao C.-L., Tsai C.-Y., Liu C.-J., Chen D.-S., Chen P.-J.;"

}
}


\keyword{utilities}
\keyword{database}

