\name{Reverse complementary}
\alias{revComp}
\alias{strComp}

% Hide revComp

\title{Performs the reverse of a sequence}
\description{
  These functions perform the reverse/complementary of a sequence. RevComp 
  loads further the result into the transparent complementary buffer.
}

\usage{
revComp(seqno=0,force=FALSE)
strComp  (s)
}
\arguments{
  \item{seqno}{Integer/scalar, Sequence number (buffer number)}
  \item{force}{Logical/scalar, Force flag (FALSE -> revComp creates the reverse/complementary 
  sequence only if it doesn't exist, TRUE -> revComp creates it anyway) }
  \item{s}{A sequence, string format.}
}

\value{
seqno or -1 if error.
}

\author{L.Cottret }

%\seealso{\code{\link{getseq}},\code{\link{shuffle}}}
\seealso{\code{\link{getSeq}}} 

\examples{
s<-"cgtagtagctagctagctagctagctag"
placeString (s, seqno=1)
getSeq(1)
# return [1] "CGTAGTAGCTAGCTAGCTAGCTAGCTAG" 
 
revComp(1)	# computes the reverse 
getSeq(1,1)
# return [1] "CTAGCTAGCTAGCTAGCTAGCTACTACG" 

# Or with strComp
strComp (s)

}
\keyword{utilities}


