\name{seqSrs}
\alias{seqSrs}
\alias{seqNcbi}
\alias{seqUrl}
\title{Download a sequence in Fasta / Genbank / Embl format from Ncbi or Srs}
\description{Get a sequence in Fasta / Genbank / Embl format trough web with only an
  accno
  
  seqUrl will get the sequence through a srs web program. seqNcbi
  will do the same with ncbi web server (I prefer this one).
}
\usage{seqSrs (accno,file="toto.seq",submotif=FALSE,
srs="http://srs.ebi.ac.uk/srsbin/cgi-bin/wgetz",
bank=c("EMBL","REFSEQ"))
seqNcbi (accno,file="toto.seq",submotif=FALSE,type="fasta")
}

\arguments{
  \item{accno}{Access Number: "dbj|BY608190.1|BY608190" or "BY608190"}
  \item{file}{file where seqence will be downloaded}
  \item{submotif}{a logical value  indicating whether we look for a
    subpatern of accno
  }
  \item{srs}{a url srs web program}
  \item{type}{fasta or genbank for seqNcbi (file format of sequence).}
  \item{bank}{List of banks to search into.}
}

\value{
  1 if file has been correctly created.
  A file containing the sequence in file format requested
}

\note{
  SeqNcbi returns sometimes Genbank file in a not very valid
    format (specially with EST sequences). These files will not be
    computed by readseq. (Use Fasta format, then).
  }
  
}


\examples{
seqNcbi("BY608190",file="BY608190.fa")


\dontrun{
# idem:
seqSrs("dbj|BY608190.1|BY608190",file="BY608190.embl",submotif=TRUE,type="embl")

seqSrs("AK129232",type="embl",srs="http://www.infobiogen.fr/srs71bin/cgi-bin/wgetz")
}
  }

\keyword{utilities}

\author{Antoine Lucas, Centre de Gntique molculaire, CNRS Gif / Yvette}

