\name{SetAccn}
\alias{setAccn}
\alias{setBegSeq}
\alias{setSeqSize}
\alias{setStrand}

\title{Set globals variables of a sequence}
\description{
  Globals variables concerning a sequence (see \code{\link{globals}})
  can be directly set with theses functions. Global variable
 \code{strand} concerns all buffers  of sequence.
}
\usage{
setAccn(name, seqno=0)
setBegSeq(pos=1, seqno=0)
setSeqSize(pos, seqno=0)

setStrand(str=0)

}
\arguments{
  \item{name}{Character: name of sequence}
  \item{seqno}{Integer: sequence number (bufno)}
  \item{pos}{Integer: size, or position.}

  \item{str}{Strand:
    0 : watson (forward)\cr
    1 : crick (reverse)
  }
}

\details{
  All details on addresses and globals variables are on page \code{\link{globals}}.
  }

\value{
  The name, or "error" if error.
}
\author{L. Cottret}

\keyword{utilities}
\seealso{\code{\link{globals}},
  \code{\link{getAccn}},
  \code{\link{setParam}},
  \code{\link{getParam}}}

