\name{SizeSeqFasta}
\alias{sizeSeqFasta}
\alias{sizeSeqGbk}
\alias{sizeSeqEmbl}

\title{Size of a sequence from a fasta/embl/gbk file}
\description{
Give the size of a sequence from a fasta/embl/gbk file.
}
\usage{
sizeSeqFasta(file,name=NA)
sizeSeqEmbl(file,name=NA, index="ix")
sizeSeqGbk(file,name=NA)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{file}{File name of the bank}
  \item{name}{Name of the sequence in the bank (default: first sequence)}
  \item{index}{character. "ix": Name is accn of sequence. \cr
    "id" : Le name is id of sequence. }
}
\value{
Size of sequence, NULL if error.
}
\author{P.Durosay(C). L.Cottret(R) }

\seealso{\code{\link{readSeq}}}

\examples{
seqNcbi("NC_004718",file="NC_004718.gbk",type="G")
sizeSeqGbk("NC_004718.gbk")
# Or:
sizeSeqGbk("NC_004718.gbk","NC_004718")



# Idem with fasta format
seqNcbi("NC_004718",file="NC_004718.fa",type="F")
sizeSeqFasta("NC_004718.fa")
# Or:
sizeSeqFasta("NC_004718.fa","gi|30271926|ref|NC_004718.3|")

\dontrun{
# With Embl
download.file("http://bioinfo.hku.hk/sars/AY291451.seq",
destfile="AY291451.seq")
sizeSeqEmbl("AY291451.seq")
}

}
\keyword{utilities}
